unit Unit2;

interface

uses
  Winapi.Windows, Winapi.Messages, System.SysUtils, System.Variants, System.Classes, Vcl.Graphics,
  Vcl.Controls, Vcl.Forms, Vcl.Dialogs, Vcl.StdCtrls, Vcl.Imaging.jpeg,
  Vcl.ExtCtrls,mmsystem;

type
  TForm2 = class(TForm)
    Button1: TButton;
    Image1: TImage;
    Edit1: TEdit;
    Memo1: TMemo;
    Label1: TLabel;
    procedure Button1Click(Sender: TObject);
    procedure Memo1Click(Sender: TObject);
    procedure Edit1KeyPress(Sender: TObject; var Key: Char);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure FormCreate(Sender: TObject);
  private
   function dicmatch(searchwords:tstringlist; buff:string):integer;  
   function getReply(dialog:string):string;
   procedure WMNchutTest(var Msg: TWMNchitTest);Message WM_NCHITTEST;
   procedure saveResult(dialog:string);
  public
    { Public 錾 }
  end;

var
  Form2: TForm2;

implementation


{$R *.dfm}

{ TForm2 }

procedure TForm2.Button1Click(Sender: TObject);
begin
 close;
end;



function TForm2.dicmatch(searchwords: tstringlist; buff: string): integer;
var
  i: Integer;
begin

result:=0;
for i := 1 to searchwords.Count-1 do
     begin
       if pos(searchwords[i-1],buff,1)<>0 then result:=result+length(searchwords[i-1]);
       
     end;

end;

procedure TForm2.Edit1KeyPress(Sender: TObject; var Key: Char);
begin
if key=#13 then
begin


  memo1.Lines.Add('Ȃ:'+edit1.Text);

  mciSendString(pchar('stop mp3file'),nil,0,0);
  mciSendString(pchar('close mp3file'),nil,0,0);
  mciSendString(pchar('open "'+getcurrentdir+'\typewriter-return-1.wav" type "waveaudio" alias mp3file'),nil,0,0);
  mciSendString(pchar('play mp3file'),nil,0,0);

  memo1.Lines.Add('O֖V:'+getReply(edit1.Text));
  saveResult(edit1.Text);
  edit1.Text:='';
  key:=#0

  end else

  begin
  mciSendString(pchar('stop mp3file'),nil,0,0);
  mciSendString(pchar('close mp3file'),nil,0,0);
  mciSendString(pchar('open "'+getcurrentdir+'\typewriter-key-1.wav" type "waveaudio" alias mp3file'),nil,0,0);
  mciSendString(pchar('play mp3file'),nil,0,0);


  end;
end;


procedure TForm2.FormClose(Sender: TObject; var Action: TCloseAction);
begin
memo1.Lines.SaveToFile('daialogs.log');
  mciSendString(pchar('stop mp3file'),nil,0,0);
  mciSendString(pchar('close mp3file'),nil,0,0);
  mciSendString(pchar('open "'+getcurrentdir+'\typewriter-return-1.wav" type "waveaudio" alias mp3file'),nil,0,0);
  mciSendString(pchar('play mp3file'),nil,0,0);
  sleep(1500);
end;

procedure TForm2.FormCreate(Sender: TObject);
begin

if fileexists('daialogs.log') then memo1.Lines.loadfromFile('daialogs.log');
  mciSendString(pchar('stop mp3file'),nil,0,0);
  mciSendString(pchar('close mp3file'),nil,0,0);
  mciSendString(pchar('open "'+getcurrentdir+'\typewriter-return-1.wav" type "waveaudio" alias mp3file'),nil,0,0);
  mciSendString(pchar('play mp3file'),nil,0,0);


end;

function TForm2.getReply(dialog: string): string;
var
 dicFile:textfile;
 reply,buff,keywords,stripDialog:string;
 ws:widestring;
 i,max:integer;
 searchwords:tstringlist;
 
begin
 if not fileexists('tansaiboou.dic') then exit;
 
 searchwords:=tstringlist.Create;
 ws:=dialog;

 stripdialog:='';
 keywords:='';
 
 for i := 1 to length(ws) do
   begin
 
     if pos(copy(ws,i,1),widestring('ĂƂȂɂʂ˂̂͂Ђӂւق܂݂ނ߂񂪂Âłǂς҂Ղ؂ۂBuv'))=0 then 
       begin
         stripdialog:=stripdialog+copy(ws,i,1); 
         keywords:=keywords+copy(ws,i,1); 
      end else if keywords<>'' then 
      begin
        searchwords.Add(keywords);
//      showmessage(keywords);
        keywords:='';
      end;
   end;
   
    if keywords<>'' then 
      begin
        searchwords.Add(keywords);
//      showmessage(keywords);
        keywords:='';
      end;

      
 max:=0;
 Assignfile(dicFile,'tansaiboou.dic');
 Reset(dicFile);
 try
   while not eof(dicFile)  do begin
   readln(dicFIle,buff);
   if (max<=dicmatch(searchwords,buff)) and (buff<>edit1.Text) then 
    begin
      reply:=buff;
      max:=dicmatch(searchwords,buff);
      if max=0 then reply:='ccc wK܂B';
      
//      showmessage(inttostr(max)+','+buff);
      
    end;
   end;
 finally
 Closefile(dicfile);
 end;


 result:=reply;

 searchwords.Free; 

end;

procedure TForm2.Memo1Click(Sender: TObject);
begin
edit1.SetFocus;

end;

procedure TForm2.saveResult(dialog:string);
var
 dicFile:textfile;

begin

 
 Assignfile(dicFile,'tansaiboou.dic');
 if fileexists('tansaiboou.dic') then  Append(dicFile) else reWrite(dicFile);

 writeln(dicFIle,dialog);
 Closefile(dicfile);
end;

procedure TForm2.WMNchutTest(var Msg: TWMNchitTest);
begin
  msg.Result:=HTCAPTION;
end;

end.
